## systemimager 2.0.1

=== Makefile ===
#
# "SystemImager" - Copyright (C) 1999-2001 Brian Elliott Finley <brian@systemimager.org> 
#
#   $Id: Makefile,v 1.44.4.2 2001/12/01 09:29:36 dannf Exp $
#
#   Written by Dann Frazier <dannf@fc.hp.com>
#
#   Others who have contributed to this code:
#     Brian Finley <brian@systemimager.org>
#
#
#
# Editing this file:
#   When adding a rule to this makefile, you should also add a properly
#   formatted comment just above.  This is so that the 'help' rules can parse
#   this file and print out a short description of the various rules.
#   Comments that begin with '#@' describe rules for use by end-users
#   (install_server, get_source, clean, etc.)  Comments that begin
#   with '#@@' describe rules that aren't intended for use by end-users, but
#   might be useful for others. Rules that aren't intended to be executed
#   directly shouldn't be commented with the '#@' notation - the assumption is
#   that if you're messing with these rules, you've opened up this file anyway,
#   so normal comments are fine.
#
# SystemImager file location standards:
#   o images will be stored in: /var/lib/systemimager/images/
#   o autoinstall scripts:      /var/lib/systemimager/scripts/
#
#   o web gui pages:            /usr/share/systemimager/web-gui/
#
#   o autoinstall kernels:      /usr/share/systemimager/`arch`-boot/
#   o initial ram disks:        /usr/share/systemimager/`arch`-boot/
#   o autoinstall binaries:     /usr/share/systemimager/`arch`-boot/
#
#   o perl libraries:           /usr/lib/systemimager/perl/
#
#   o docs:                     Use distribution appropriate location.
#                               Defaults to /usr/share/doc/systemimager/ 
#                               for installs from tarball or source.
#
#   o man pages:                /usr/share/man/man8/
#
#   o log files:                /var/log/systemimager/
#
#   o configuration files:      /etc/systemimager/
#   o rsyncd.conf:              /etc/systemimager/rsyncd.conf
#   o rsyncd init script:       /etc/init.d/systemimager
#   
#   o tftp files will be copied to the appropriate destination (as determined
#     by the local SysAdmin when running "mkbootserver".
#
#   o user visible binaries:    /usr/local/bin (default)
#     (lsimage, mkautoinstalldiskette, mkautoinstallcd)
#   o sysadmin binaries:        /usr/local/sbin (default)
#     (all other binaries)
#
# Standards for pre-defined rsync modules:
#   o scripts
#   o <arch>-boot (Ie., i386-boot -- dynamically determine in rcS)
#     (do an 
#       ARCH=`uname -m | sed 's/i[3-6]86/i386/'`
#     in the rcS script)
#
# Where should the server side exclude file be stored?
# currently it is the only file in /usr/lib/systemimager/systemimager
# maybe /etc/systemimager/systemimager.exclude?
#

DESTDIR =
VERSION = $(shell cat VERSION)

# RELEASE_DOCS are toplevel files that should be included with all posted
# tarballs, but aren't installed onto the destination machine by default
RELEASE_DOCS = CHANGE.LOG COPYING CREDITS ERRATA README TODO VERSION

PATH = /sbin:/bin:/usr/sbin:/usr/bin:/usr/bin/X11:/usr/local/sbin:/usr/local/bin
ARCH = $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
SUDO = $(shell if [ `id -u` != 0 ]; then echo -n "sudo"; fi)

TEMP_DIR = systemimager.initrd.temp.dir/
TARBALL_BUILD_DIR = autoinstallbin/

MANUAL_DIR = doc/manual_source/
MANPAGE_DIR = doc/man/
PATCH_DIR = patches/
LIB_SRC = lib/SystemImager/
SRC_DIR = src/
BINARY_SRC = sbin/
CLIENT_BINARY_SRC = tftpstuff/systemimager
COMMON_BINARY_SRC = $(BINARY_SRC)

# destination directories
ETC  = $(DESTDIR)/etc
INITD = $(ETC)/init.d
USR = $(DESTDIR)/usr/local
DOC  = $(USR)/share/doc/systemimager-doc
BIN = $(USR)/bin
SBIN = $(USR)/sbin
MAN8 = $(USR)/share/man/man8
LIB_DEST = $(USR)/lib/systemimager/perl/SystemImager
LOG_DIR = $(DESTDIR)/var/log/systemimager

INITSCRIPT_NAME = systemimager

TFTP_BIN_SRC      = tftpstuff/systemimager
TFTP_BIN         := raidstart mkraid mkreiserfs prepareclient updateclient
TFTP_ROOT	  = $(USR)/share/systemimager
TFTP_BIN_DEST     = $(TFTP_ROOT)/$(ARCH)-boot

PXE_CONF_SRC      = tftpstuff/pxelinux.cfg
PXE_CONF_DEST     = $(TFTP_BIN_DEST)/pxelinux.cfg

AUTOINSTALL_TARBALL = autoinstallbin.tar.gz

BINARIES := makeautoinstallcd makeautoinstalldiskette mkautoinstallcd mkautoinstalldiskette
SBINARIES := addclients cpimage getimage makedhcpserver makedhcpstatic mkdhcpserver mkdhcpstatic mkautoinstallscript mkbootserver mvimage pushupdate rmimage
CLIENT_SBINARIES  := updateclient prepareclient
COMMON_BINARIES   = lsimage

IMAGESRC    = ./var/spool/systemimager/images
IMAGEDEST   = $(DESTDIR)/var/lib/systemimager/images
WARNING_FILES = $(IMAGEDEST)/README $(IMAGEDEST)/DO_NOT_TOUCH_THESE_DIRECTORIES $(IMAGEDEST)/CUIDADO $(IMAGEDEST)/ACHTUNG
AUTOINSTALL_SCRIPT_DIR = $(DESTDIR)/var/lib/systemimager/scripts

LINUX_SRC = $(SRC_DIR)/linux
LINUX_VERSION = 2.2.18
LINUX_TARBALL = linux-$(LINUX_VERSION).tar.bz2
LINUX_URL = http://www.kernel.org/pub/linux/kernel/v2.2/$(LINUX_TARBALL)
LINUX_MD5SUM = 9a8f4b1003ff6b096678d193fd438467
LINUX_IMAGE = $(LINUX_SRC)/arch/i386/boot/bzImage
LINUX_PATCH = $(PATCH_DIR)/linux.patch
LINUX_CONFIG = $(PATCH_DIR)/linux.config

INITRD_DIR = initrd_source
INITRD = $(INITRD_DIR)/initrd.gz

RAIDTOOLS_DIR = $(SRC_DIR)/raidtools-0.90
RAIDTOOLS_TARBALL = raidtools-19990824-0.90.tar.bz2
RAIDTOOLS_URL = http://www.kernel.org/pub/linux/daemons/raid/alpha/$(RAIDTOOLS_TARBALL)
RAIDTOOLS_PATCH = $(PATCH_DIR)/raidtools.patch
RAIDTOOLS_MD5SUM = 8a8460ae6731fa4debd912297c2402ca
REISERFSPROGS_DIR = $(LINUX_SRC)/fs/reiserfs/utils

WGET = wget --passive-ftp

#@all:
#@  build everything, install nothing
#@ 
all:	raidtools reiserfsprogs kernel initrd docs manpages

#@install_server_all:
#@  a complete server install
#@ 
install_server_all:	install_server install_common install_binaries

#@install_client_all:
#@  a complete client install
#@ 
install_client_all:	install_client install_common

#@@install_server:
#@@  install server-only architecture independent files
#@@ 
install_server:	install_manpages install_configs install_server_libs
	mkdir -p $(BIN)
	mkdir -p $(SBIN)
	$(foreach binary, $(BINARIES), \
		install -m 755 $(BINARY_SRC)/$(binary) $(BIN);)
	$(foreach binary, $(SBINARIES), \
		install -m 755 $(BINARY_SRC)/$(binary) $(SBIN);)
	install -d -m 755 $(LOG_DIR)
	install -d -m 755 $(TFTP_BIN_DEST)
	install -d -m 755 $(AUTOINSTALL_SCRIPT_DIR)
	install -d -m 755 $(PXE_CONF_DEST)
	install -m 644 --backup $(PXE_CONF_SRC)/message.txt \
		$(PXE_CONF_DEST)/message.txt
	install -m 644 --backup $(PXE_CONF_SRC)/syslinux.cfg \
		$(PXE_CONF_DEST)/syslinux.cfg
	install -m 644 --backup $(PXE_CONF_SRC)/syslinux.cfg \
		$(PXE_CONF_DEST)/default
	install -m 755 $(TFTP_BIN_SRC)/prepareclient $(TFTP_BIN_DEST)
	install -m 755 $(TFTP_BIN_SRC)/updateclient $(TFTP_BIN_DEST)
	install -d -m 755 $(IMAGEDEST)
	$(foreach file, $(WARNING_FILES), \
		install -m 644 $(IMAGESRC)/README $(file);)

#@@install_client:
#@@  install client-only files
#@@ 
install_client: install_client_manpages install_client_libs
	mkdir -p $(ETC)/systemimager
	install -b -m 644 tftpstuff/systemimager/updateclient.local.exclude \
		$(ETC)/systemimager
	mkdir -p $(SBIN)

	$(foreach binary, $(CLIENT_SBINARIES), \
		install -m 755 $(CLIENT_BINARY_SRC)/$(binary) $(SBIN);)

#@@install_common:
#@@  install files common to both the server and client
#@@ 
install_common:	install_common_manpages install_common_libs
	mkdir -p $(BIN)
	$(foreach binary, $(COMMON_BINARIES), \
		install -m 755 $(COMMON_BINARY_SRC)/$(binary) $(BIN);)

#@@install_server_libs:
#@@  install server-only libraries
#@@ 
install_server_libs:
	mkdir -p $(LIB_DEST)
	cp $(LIB_SRC)/Server.pm $(LIB_DEST)

#@@install_client_libs:
#@@  install client-only libraries
#@@ 
install_client_libs:
	mkdir -p $(LIB_DEST)
	cp $(LIB_SRC)/Client.pm $(LIB_DEST)

#@@install_common_libs:
#@@  install common libraries
#@@ 
install_common_libs:
	mkdir -p $(LIB_DEST)
	cp $(LIB_SRC)/Common.pm $(LIB_DEST)

#@@install_binaries:
#@@  install architecture-dependent files
#@@ 
install_binaries:	install_raidtools install_reiserfsprogs install_kernel install_initrd


########## BEGIN raidtools ##########

#@@install_raidtools:
#@@  install the raidtools binaries (pulled by some autoinstall clients)
#@@ 
install_raidtools:	raidtools
	mkdir -p $(TFTP_BIN_DEST)
	install -m 755 $(RAIDTOOLS_DIR)/mkraid $(TFTP_BIN_DEST)
	install -m 755 $(RAIDTOOLS_DIR)/raidstart $(TFTP_BIN_DEST)
	cp -a $(TFTP_BIN_DEST)/raidstart $(TFTP_BIN_DEST)/raidstop

#@@raidtools:
#@@  build the raidtools binaries
#@@ 
raidtools:	raidtools-build-stamp

raidtools-build-stamp:
	$(MAKE) $(SRC_DIR)/$(RAIDTOOLS_TARBALL)
	[ -d $(RAIDTOOLS_DIR) ] || \
		( cd $(SRC_DIR) && bzcat $(RAIDTOOLS_TARBALL) | tar xv && \
		  [ ! -f ../$(RAIDTOOLS_PATCH) ] || \
		  patch -p0 < ../$(RAIDTOOLS_PATCH) )
	( cd $(RAIDTOOLS_DIR) && ./configure )
	$(MAKE) -C $(RAIDTOOLS_DIR)
	touch raidtools-build-stamp

# download the raidtools tarball
$(SRC_DIR)/$(RAIDTOOLS_TARBALL):
	[ -d $(SRC_DIR) ] || mkdir -p $(SRC_DIR)
	cd $(SRC_DIR) && $(WGET) $(RAIDTOOLS_URL)
	[ "$(RAIDTOOLS_MD5SUM)" == \
		`md5sum $(SRC_DIR)/$(RAIDTOOLS_TARBALL) | cut -d " " -f 1` ] \
		|| exit 1
########## END raidtools ##########

######### BEGIN reiserfsprogs ##########

#@@install_reiserfsprogs:
#@@  install a statically linked mkreiserfs binary - this is retrieved by
#@@  autoinstall clients that use the reiser filesystem
#@@ 
install_reiserfsprogs:	reiserfsprogs
	mkdir -p $(TFTP_BIN_DEST)
	install -m 755 $(REISERFSPROGS_DIR)/bin/mkreiserfs $(TFTP_BIN_DEST)

#@@reiserfsprogs:
#@@  build statically-linked reiserfsprogs	
#@@ 
reiserfsprogs:	reiserfsprogs-build-stamp

reiserfsprogs-build-stamp:
	make patched_kernel
	make -C $(REISERFSPROGS_DIR)
	touch reiserfsprogs-build-stamp

######### END reiserfsprogs ##########

########## BEGIN kernel ##########
#@@install_kernel:
#@@  install the kernel that autoinstall clients will boot from during
#@@  autoinstallation
#@@ 
install_kernel:	kernel
	mkdir -p $(TFTP_BIN_DEST)
	cp -a $(LINUX_IMAGE) $(TFTP_BIN_DEST)/kernel

#@@kernel:
#@@  build the kernel that autoinstall clients will boot from during
#@@  autoinstallation
#@@ 
kernel:	kernel-build-stamp

kernel-build-stamp:
	$(MAKE) patched_kernel
	$(MAKE) -C $(LINUX_SRC) oldconfig dep bzImage
	touch kernel-build-stamp

patched_kernel:	patched_kernel-stamp

patched_kernel-stamp:
	$(MAKE) $(SRC_DIR)/$(LINUX_TARBALL)
	[ -d $(LINUX_SRC) ] || \
		( cd $(SRC_DIR) && bzcat $(LINUX_TARBALL) | tar xv && \
		  [ ! -f ../$(LINUX_PATCH) ] || \
		  patch -p0 < ../$(LINUX_PATCH) || /bin/true )
	cp -a $(LINUX_CONFIG) $(LINUX_SRC)/.config
	touch patched_kernel-stamp

$(SRC_DIR)/$(LINUX_TARBALL):
	[ -d $(SRC_DIR) ] || mkdir -p $(SRC_DIR)
	cd $(SRC_DIR) && $(WGET) $(LINUX_URL)
	[ "$(LINUX_MD5SUM)" == \
		`md5sum $(SRC_DIR)/$(LINUX_TARBALL) | cut -d " " -f 1` ] || \
		exit 1

########## END kernel ##########

########## BEGIN initrd ##########

#@@install_initrd:
#@@  install the autoinstall ramdisk - the initial ramdisk used by autoinstall
#@@  clients when beginning an autoinstall
#@@ 
install_initrd:
	$(MAKE) initrd
	mkdir -p $(TFTP_BIN_DEST)
	install -m 644 $(INITRD_DIR)/initrd.gz $(TFTP_BIN_DEST)

#@@initrd:
#@@  build the autoinstall ramdisk
#@@ 
initrd:	initrd-build-stamp

initrd-build-stamp:
	make -C $(INITRD_DIR)
	touch initrd-build-stamp

#@@install_configs:
#@@  install the initscript & config files
#@@ 
install_configs:
	mkdir -p $(ETC)/systemimager
	install -b -m 644 etc/rsyncd.conf $(ETC)/systemimager
	install -b -m 644 etc/systemimager.conf $(ETC)/systemimager
	[ "$(INITD)" != "" ] || exit 1
	mkdir -p $(INITD)
	install -b -m 755 etc/init.d/rsync $(INITD)/$(INITSCRIPT_NAME)

########## END initrd ##########

########## BEGIN man pages ##########

#@@install_manpages
#@@  install the manpages for the server
#@@ 
install_manpages:	manpages
	mkdir -p $(MAN8)
	$(foreach binary, $(BINARIES) $(SBINARIES), \

=== initrd_source/Makefile ===
DESTDIR =

PATH = /sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin

SUDO = $(shell if [ `id -u` != 0 ]; then echo -n "sudo"; fi)
WGET = wget --passive-ftp

# where utilities that may need to be retrieved
# by autoinstall clients are stored
TFTPROOT = $(DESTDIR)/usr/lib/systemimager

PATCH_DIR = ./patches
SRC_DIR = ./src

TEMP_DIR = ./systemimager.initrd.temp.dir
INITRD_SIZE = 2600       # number of 1KB blocks in ramdisk.
INITRD_INODE_COUNT = 700 # number of inodes available on ramdisk

########## BEGIN definitions for binaries built from source ##########

BEEP_VERSION = 1.2.1
BEEP_ROOT = $(SRC_DIR)/beep-$(BEEP_VERSION)
BEEP_BINARY = $(BEEP_ROOT)/beep
BEEP_TARBALL = beep-$(BEEP_VERSION).tar.gz
BEEP_URL = http://www.johnath.com/beep/$(BEEP_TARBALL)
BEEP_PATCH = $(PATCH_DIR)/beep.patch

BUSYBOX_VERSION = 0.60.0
BUSYBOX_ROOT = $(SRC_DIR)/busybox-$(BUSYBOX_VERSION)
BUSYBOX_BINARY = $(BUSYBOX_ROOT)/busybox
BUSYBOX_TARBALL = busybox-$(BUSYBOX_VERSION).tar.gz
BUSYBOX_URL = ftp://opensource.lineo.com/busybox/$(BUSYBOX_TARBALL)

########## END definitions for binaries built from source ##########

# tools provided by busybox (i.e. hard links to create)
BUSY_BIN := cat chgrp chmod chown cp df dmesg grep hostname kill ln ls mkdir mknod more mount mv ping ps pwd rm rmdir sed sleep sync touch umount uname ifconfig route
BUSY_SBIN := halt init insmod loadkmap makedevs mkswap reboot swapoff swapon update
BUSY_USR_BIN := clear cut expr find free killall reset telnet tr
BUSY_USR_SBIN := chroot

# these binaries will be copied over from the local system
LOCAL_BINARIES := /sbin/sfdisk /usr/bin/mawk /sbin/mke2fs /bin/ash /usr/bin/rsync /usr/bin/snarf /sbin/dhclient-2.2.x /usr/bin/host

initrd.gz:	initrd
	gzip -9 < initrd > initrd.gz

initrd:	binary-build-stamp $(LOCAL_BINARIES)
	# create ramdisk file & mount it as a filesystem
	dd if=/dev/zero of=initrd bs=1k count=$(INITRD_SIZE)
	mke2fs -N $(INITRD_INODE_COUNT) -m 0 -q -F initrd
	mkdir -p $(TEMP_DIR)

	# umount the ramdisk if it is already mounted due to a previous failure
	-$(SUDO) umount $(TEMP_DIR)
	$(SUDO) mount initrd $(TEMP_DIR) -o loop

	# create directory structure
	cd $(TEMP_DIR) && mkdir -m 755 bin dev etc lib proc root sbin usr var
	cd $(TEMP_DIR) && mkdir -m 1777 tmp
	cd $(TEMP_DIR) && mkdir -m 755 usr/bin usr/sbin etc/init.d var/run

	# make /dev/entries
	$(SUDO) ./dupdevs.sh $(TEMP_DIR)/dev < dev_ls-lR

	# create hardlinks to busybox
	cp -a $(BUSYBOX_BINARY) $(TEMP_DIR)/bin
	cd $(TEMP_DIR) && $(foreach tool, $(BUSY_BIN), \
		ln ./bin/busybox ./bin/$(tool); )
	cd $(TEMP_DIR) && $(foreach tool, $(BUSY_SBIN), \
		ln ./bin/busybox ./sbin/$(tool); )
	cd $(TEMP_DIR) && $(foreach tool, $(BUSY_USR_BIN), \
		ln ./bin/busybox ./usr/bin/$(tool); )
	cd $(TEMP_DIR) && $(foreach tool, $(BUSY_USR_SBIN), \
		ln ./bin/busybox ./usr/sbin/$(tool); )

	# copy over other binaries
	cp -a $(BEEP_BINARY) $(LOCAL_BINARIES) $(TEMP_DIR)/bin
	mv $(TEMP_DIR)/bin/dhclient-2.2.x $(TEMP_DIR)/bin/dhclient

	cd $(TEMP_DIR) && ln ./bin/ash ./bin/sh

	# copy over text files from the skel directory
	cp -a ./skel/* $(TEMP_DIR)

	# clear out CVS cruft
	find $(TEMP_DIR) -type d -name CVS -depth | xargs rm -rf

	# copy over libs that massdns won't build
	cp -a /lib/libnss_dns* $(TEMP_DIR)/lib

	# create small dynamic libraries
	./mklibs.sh -v -d $(TEMP_DIR)/lib $(TEMP_DIR)/lib/* $(TEMP_DIR)/bin/* \
	  $(TEMP_DIR)/sbin/*  $(TEMP_DIR)/usr/bin/* $(TEMP_DIR)/usr/sbin/*

	$(SUDO) chown 0 -R $(TEMP_DIR)/*
	$(SUDO) chgrp 0 -R $(TEMP_DIR)/*

	$(SUDO) umount $(TEMP_DIR) && rmdir $(TEMP_DIR)

install:	initrd.gz
	mkdir $(TFTPROOT)
	cp -a initrd.gz $(TFTPROOT)

# binaries that we build from source
binaries:	binary-build-stamp

binary-build-stamp:
	$(MAKE) beep busybox
	touch binary-build-stamp

########## BEGIN beep rules ##########

beep:
	$(MAKE) $(SRC_DIR)/$(BEEP_TARBALL)
	[ -d $(BEEP_ROOT) ] || \
		( cd $(SRC_DIR) && tar xvfz $(BEEP_TARBALL) && \
		  [ ! -f ../$(BEEP_PATCH) ] || \
		  patch -p0 < ../$(BEEP_PATCH) )
	$(MAKE) -C $(BEEP_ROOT) beep
	strip $(BEEP_BINARY)

$(SRC_DIR)/$(BEEP_TARBALL):
	[ -d $(SRC_DIR) ] || mkdir -p $(SRC_DIR)
	cd $(SRC_DIR) && $(WGET) $(BEEP_URL)

########## END beep rules ##########

########## BEGIN busybox rules ##########

busybox:
	$(MAKE) $(SRC_DIR)/$(BUSYBOX_TARBALL)
	[ -d $(BUSYBOX_ROOT) ] || \
		( cd $(SRC_DIR) && tar xvfz $(BUSYBOX_TARBALL) )
	cp -a busybox.Config.h $(BUSYBOX_ROOT)/Config.h
	$(MAKE) -C $(BUSYBOX_ROOT) busybox
	strip $(BUSYBOX_BINARY)

$(SRC_DIR)/$(BUSYBOX_TARBALL):
	[ -d $(SRC_DIR) ] || mkdir -p $(SRC_DIR)
	cd $(SRC_DIR) && $(WGET) $(BUSYBOX_URL)

########## END busybox rules ##########

get_source:	$(SRC_DIR)/$(BEEP_TARBALL) $(SRC_DIR)/$(BUSYBOX_TARBALL)

help:
	@echo ' This Makefile provides rules to create a ramdisk (initrd.gz) for'
	@echo ' SystemImager autoinstall clients.  '
	@echo ''
	@echo ' Steps for the Chronically Impatient'
	@echo ' -----------------------------------'
	@echo ' 1) Do a "make get_source".'
	@echo ' 2) Modify the source code as desired.'
	@echo ' 3) Modify the init script as desired "vi skel/etc/init.d/rcS".'
	@echo ' 4) Modify any other configuration files as desired.  Most of these'
	@echo '    are in the "skel" directory. (skel is short for skeleton files)'
	@echo ' 5) Modify "dev_ls-lR" to add or remove device entries.'
	@echo ' 5) Run "make install"'
	@echo ''
	@echo ''
	@echo ' Details so that the Impatient can know what broke'
	@echo ' -------------------------------------------------'
	@echo ' Here are descriptions of the various rules:'
	@echo ''
	@echo ' make initrd.gz          makes a complete compressed ramdisk'
	@echo ''
	@echo ' make initrd             makes a complete uncompressed ramdisk'
	@echo ''
	@echo ' make install            installs a complete compressed ramdisk'
	@echo '                         to $(TFTPROOT)'
	@echo ''
	@echo ' make binaries           downloads the source for and builds'
	@echo '                         all required binaries that are not'
	@echo '                         a part of the Debian/unstable distro'
	@echo '                         (binaries that are in Debian/unstable'
	@echo '                         are just copied over from the local'
	@echo '                         system)'
	@echo ''
	@echo ' make <binary>           downloads the source for and builds'
	@echo '                         a single required binary that is not'
	@echo '                         a part of the Debian/unstable distro'
	@echo '                         (binaries that are in Debian/unstable'
	@echo '                         are just copied over from the local'
	@echo '                         system)'
	@echo ''
	@echo ' make get_source         download the source for all binaries'
	@echo '                         that are required, but not a part'
	@echo '                         of Debian/unstable.'
	@echo ''
	@echo ' make help               print this message'
	@echo ''
	@echo ' make helpless           pipe this message through less'
	@echo ''
	@echo ' make clean              execute the clean rule in the source'
	@echo '                         tree for each utility, remove editor'
	@echo '                         backup files and files that have'
	@echo '                         already been built.'
	@echo ''
	@echo ' make distclean          make clean + remove all downloaded'
	@echo '                         tarballs & their build trees.'
	@echo ''
	@echo ' Please read the README.initrd for more build and customization'
	@echo ' details.'

helpless:
	$(MAKE) help | less

clean:
	-$(MAKE) -C $(BUSYBOX_ROOT) clean
	-$(MAKE) -C $(BEEP_ROOT) clean
	-find . -name "*~" -exec rm -f {} \;
	-$(SUDO) umount $(TEMP_DIR)
	-rm -rf $(TEMP_DIR) initrd initrd.gz
	-rm -rf binary-build-stamp
distclean:	clean
	-rm -rf $(SRC_DIR)

=== doc/man/Makefile ===
SECTION = 8

compress:	prepareclient.8.gz updateclient.8.gz addclients.8.gz getimage.8.gz mkautoinstallcd.8.gz mkautoinstalldiskette.8.gz mkautoinstallscript.8.gz mkdhcpserver.8.gz mkdhcpstatic.8.gz lsimage.8.gz pushupdate.8.gz cpimage.8.gz mvimage.8.gz rmimage.8.gz mkbootserver.8.gz

manpages:	prepareclient.8 updateclient.8 addclients.8 getimage.8 mkautoinstallcd.8 mkautoinstalldiskette.8 mkautoinstallscript.8 mkdhcpserver.8 mkdhcpstatic.8 lsimage.8 pushupdate.8 cpimage.8 mvimage.8 rmimage.8 mkbootserver.8

prepareclient.8.gz:	prepareclient.8
	gzip -9 < prepareclient.8 > prepareclient.8.gz

prepareclient.8:	prepareclient.sgml
	docbook-to-man prepareclient.sgml > prepareclient.8

pushupdate.8.gz:	pushupdate.8
	gzip -9 < pushupdate.8 > pushupdate.8.gz

pushupdate.8:	pushupdate.sgml
	docbook-to-man pushupdate.sgml > pushupdate.8

lsimage.8.gz:	lsimage.8
	gzip -9 < lsimage.8 > lsimage.8.gz

lsimage.8:	lsimage.sgml
	docbook-to-man lsimage.sgml > lsimage.8

updateclient.8.gz:	updateclient.8
	gzip -9 < updateclient.8 > updateclient.8.gz

updateclient.8:	updateclient.sgml
	docbook-to-man updateclient.sgml > updateclient.8

addclients.8.gz:	addclients.8
	gzip -9 < addclients.8 > addclients.8.gz

addclients.8:	addclients.sgml
	docbook-to-man addclients.sgml > addclients.8

getimage.8.gz:	getimage.8
	gzip -9 < getimage.8 > getimage.8.gz

getimage.8:	getimage.sgml
	docbook-to-man getimage.sgml > getimage.8

mkautoinstallcd.8.gz:	mkautoinstallcd.8
	gzip -9 < mkautoinstallcd.8 > mkautoinstallcd.8.gz

mkautoinstallcd.8:	mkautoinstallcd.sgml
	docbook-to-man mkautoinstallcd.sgml > mkautoinstallcd.8

mkautoinstalldiskette.8.gz:	mkautoinstalldiskette.8
	gzip -9 < mkautoinstalldiskette.8 > mkautoinstalldiskette.8.gz

mkautoinstalldiskette.8:	mkautoinstalldiskette.sgml
	docbook-to-man mkautoinstalldiskette.sgml > mkautoinstalldiskette.8

mkautoinstallscript.8.gz:	mkautoinstallscript.8
	gzip -9 < mkautoinstallscript.8 > mkautoinstallscript.8.gz

mkautoinstallscript.8:	mkautoinstallscript.sgml
	docbook-to-man mkautoinstallscript.sgml > mkautoinstallscript.8

mkdhcpstatic.8.gz:	mkdhcpstatic.8
	gzip -9 < mkdhcpstatic.8 > mkdhcpstatic.8.gz

mkdhcpstatic.8:	mkdhcpstatic.sgml
	docbook-to-man mkdhcpstatic.sgml > mkdhcpstatic.8

mkdhcpserver.8.gz:	mkdhcpserver.8
	gzip -9 < mkdhcpserver.8 > mkdhcpserver.8.gz

mkdhcpserver.8:	mkdhcpserver.sgml
	docbook-to-man mkdhcpserver.sgml > mkdhcpserver.8

cpimage.8.gz:	cpimage.8
	gzip -9 < cpimage.8 > cpimage.8.gz

cpimage.8:	cpimage.sgml
	docbook-to-man cpimage.sgml > cpimage.8

mvimage.8.gz:	mvimage.8
	gzip -9 < mvimage.8 > mvimage.8.gz

mvimage.8:	mvimage.sgml
	docbook-to-man mvimage.sgml > mvimage.8

rmimage.8.gz:	rmimage.8
	gzip -9 < rmimage.8 > rmimage.8.gz

rmimage.8:	rmimage.sgml
	docbook-to-man rmimage.sgml > rmimage.8

mkbootserver.8.gz:	mkbootserver.8
	gzip -9 < mkbootserver.8 > mkbootserver.8.gz

mkbootserver.8:	mkbootserver.sgml
	docbook-to-man mkbootserver.sgml > mkbootserver.8

clean:
	rm -f *~ \#*\# *.8 *.gz

=== doc/manual_source/Makefile ===
#
# "SystemImager" - Copyright (C) 1999-2001 Brian Elliott Finley <brian@systemimager.org>
#
# This file is: Makefile
#               (Create documentation from SGML source)
#
#               Written by: Dann Frazier <dannf@ldl.fc.hp.com>
#

NAME	= systemimager-manual
SRC	= $(NAME).sgml
HTMLDIR = html
SGMLTOOLS = $(shell which sgmltools)

all:    html ps pdf dvi rtf

dvi:	$(NAME).dvi
pdf:    $(NAME).pdf
ps:	$(NAME).ps
rtf:	$(NAME).rtf

html:	$(SGMLTOOLS) $(SRC)
	$(SGMLTOOLS) -b html $(SRC)
	mkdir $(HTMLDIR)
	mv $(NAME)/* $(HTMLDIR)
	rmdir $(NAME)
	cp -a images/ $(HTMLDIR)/images

$(NAME).dvi:	$(SGMLTOOLS) $(SRC)
	$(SGMLTOOLS) -b dvi $(SRC)
$(NAME).pdf:	$(SGMLTOOLS) $(SRC)
	$(SGMLTOOLS) -b pdf $(SRC)
$(NAME).ps:	$(SGMLTOOLS) $(SRC)
	$(SGMLTOOLS) -b ps $(SRC)
$(NAME).rtf:	$(DB2RTF) $(SRC)
	$(SGMLTOOLS) -b rtf $(SRC)
clean:
	find . -name "*~" -exec rm -f {} \;
	find . -name "#*#" -exec rm -f {} \;
	rm -rf $(NAME).aux $(NAME).dvi $(NAME).log $(NAME).out $(NAME).pdf \
	  $(NAME).ps $(NAME).rtf $(NAME).tex $(HTMLDIR) $(NAME) \
	  DBTOHTML_OUTPUT_DIR*

## systemimager 3.2.2-3

=== debian/changelog ===
systemimager (3.2.2-3) unstable; urgency=low

  * Include patch from Ian Wienand that fixes DNS lookups on ia64.
    Closes: #252207

 -- dann frazier <dannf@debian.org>  Sun, 13 Jun 2004 21:17:45 -0600

systemimager (3.2.2-2) unstable; urgency=low

  * remove ia64 build-dep on gcc-3.2

 -- dann frazier <dannf@debian.org>  Sat, 17 Apr 2004 15:13:47 -0600

systemimager (3.2.2-1) unstable; urgency=low

  * new upstream release
  * we can now build w/ gcc 3.3.  Closes: #236459
  * add sysutils as a build-dep.  Closes: #241970
  * depend on dosfstools.  Closes: #226891

 -- dann frazier <dannf@debian.org>  Wed, 14 Apr 2004 00:04:17 -0600

systemimager (3.2.0-2) unstable; urgency=low

  * fix systemimager-boot conflicts, which were making it uninstallable.

 -- dann frazier <dannf@debian.org>  Mon, 15 Mar 2004 09:51:30 -0700

systemimager (3.2.0-1) unstable; urgency=low

  * New upstream release

 -- dann frazier <dannf@debian.org>  Tue, 02 Mar 2004 22:30:46 -0700

systemimager (3.1.8-1) unstable; urgency=low

  * New upstream devel release

 -- dann frazier <dannf@debian.org>  Wed, 26 Nov 2003 22:42:01 -0700

systemimager (3.0.1-9) unstable; urgency=low

  * split out binary-arch & binary-indep.
    Note that the split is somewhat abnormal - the binary-arch target will
    build an arch: all package - however, the package it creates is determined
    by the build-arch.  For example, on i386 it will build
    systemimager-boot-i386-standard, and on ia64 it will build
    systemimager-boot-ia64-standard.  I think this fits the spirit of the
    split (binary-arch should build the packages that can only be built on
    this architecture), although it differs from how it is defined.
    I also realize that this won't make the buildd's happy - they don't 
    expect binary-all packages to pop out during a binary-arch build.
    However, the buildd's can't help with systemimager builds anyway,
    so I'll need to revert to P-a-S status anyway.  Closes: #208724
  * added bison as a build-dep.  Closes: #208715
  * added gettext as a build-dep.  Closes: #209302
  * add gcc-3.2 as a build-dep for ia64 (gcc 3.3 won't build the kernel)
  
 -- dann frazier <dannf@dannf.org>  Mon, 01 Sep 2003 22:54:24 -0600

systemimager (3.0.1-8) unstable; urgency=low

  * patch modutils to build w/ new lex (patch stolen from modutils pkg).
  * force gcc-3.2 to be used when building the ia64 kernel - thanks bdale. 
    Closes: #205315
  * added groff-base as a build-dep - thanks Daniel Schepler. Closes: #203998
  * install example elilo.conf - thanks taggart.  Closes: #206493
  * include libnss_dns in boel_binaries for non-x86 (non-uclibc) arches (ia64)
    so dns can be used to determine hostname

 -- dann frazier <dannf@dannf.org>  Mon, 01 Sep 2003 22:54:24 -0600

systemimager (3.0.1-7) unstable; urgency=low

  * fixes creation of autoinstallcds on ia64.
  * Fixed some getimage typos.  Closes: #198237

 -- dann frazier <dannf@dannf.org>  Sat, 21 Jun 2003 15:59:14 -0600

systemimager (3.0.1-6) unstable; urgency=low

  * added missing build-dep on groff.  Closes: #197941

 -- dann frazier <dannf@debian.org>  Thu, 19 Jun 2003 00:10:15 -0600 
	

systemimager (3.0.1-5) unstable; urgency=low

  * add support for multiple -exclude options to getimage.  Closes: #179995
  * add some more files to the default updateclient.local.exclude file
    thanks to Mark Ferlatte for pointing them out.  Closes: 188091
	
 -- dann frazier <dannf@debian.org>  Sun, 15 Jun 2003 17:33:15 -0600
	

systemimager (3.0.1-4) unstable; urgency=low

  * add patches for discover & parted so we can build w/ gcc 3.3
  * remerged the boot packages build goo into the systemimager source
    package - thanks to John Morton for the patch.  Closes: #194721
  * explicity unset $PREFIX when installing uclibc.  Closes: #191492
  * don't ignore failures when executing the binaries rule.  Closes: #195999
  * add texinfo (needed by e2fsprogs) and modutils to Build-Depends.
    Closes: #195996.  Thanks to Daniel Schepler for reporting these.
	
 -- dann frazier <dannf@debian.org>  Sat, 07 Jun 2003 14:14:13 -0600
	

systemimager (3.0.1-3) unstable; urgency=low

  * deal w/ new sfdisk printing mebibytes instead of megabytes.
    thanks to Jose Celestino.  Closes: #187397
	
 -- dann frazier <dannf@debian.org>  Sun, 06 Apr 2003 23:32:18 -0600
	

systemimager (3.0.1-2) unstable; urgency=low

  * Cleanup of the description and synopsis.  Closes: #186932
	
 -- dann frazier <dannf@debian.org>  Mon, 31 Mar 2003 21:51:45 -0700
	

systemimager (3.0.1-1) unstable; urgency=low

  * new upstream release
	
 -- dann frazier <dannf@debian.org>  Sun, 30 Mar 2003 12:34:05 -0700
	

systemimager (3.0.0-3) unstable; urgency=low

  * removed Bugs: entry from control
  * added dhcp3-server as an or'd recommend w/ dhcp.  Closes: #179305
  * versioned the dependency on systemconfigurator. Closes: #178930
  * added bug fixes stolen from stable cvs branch
  * added bc build-dep
	
 -- dann frazier <dannf@debian.org>  Sun,  2 Feb 2003 19:05:19 -0700
	

systemimager (3.0.0-2) unstable; urgency=low

  * The remember to run lintian this time release
  * add rsync security warning to addclients and getimage
  * update debian/copyright
  * stop building ps version of manual - sgml tools are broken in unstable
  * removed duplicate conffiles entries
  * moved systemimager-doc into section doc

 -- dann frazier <dannf@debian.org>  Sun, 15 Dec 2002 01:16:58 -0700

systemimager (3.0.0-1) unstable; urgency=low

  * new upstream release

 -- dann frazier <dannf@debian.org>  Sun, 08 Dec 2002 22:50:36 -0700

systemimager (2.9.5-1) experimental; urgency=low

  * new upstream release

 -- dann frazier <dannf@hp.com>  Mon, 18 Nov 2002 18:23:00 -0700

systemimager (2.9.4-2) experimental; urgency=low

  * made '/etc/init.d/netbootmond stop' exit non-zero if it never started

 -- dann frazier <dannf@debian.org>  Sat, 02 Nov 2002 12:00:16 -0700
	

systemimager (2.9.4-1) experimental; urgency=low
  


=== debian/control ===
Source: systemimager
Section: admin
Priority: optional
Maintainer: dann frazier <dannf@debian.org>
Build-Depends: bc, bin86 [i386], bison, bzip2, cramfsprogs (>= 1.1-4), debhelper (>> 2.0.0), flex, gettext, groff-base, libpopt-dev, libtool, libreadline4-dev, modutils, sysutils, texinfo, util-linux, uuid-dev
Build-Conflicts: libc6.1-pic
Build-Depends-Indep: bc, bzip2, debhelper (>> 2.0.0), docbook-to-man, docbook-utils, jadetex, sgmltools-lite
Standards-Version: 3.5.7

Package: systemimager-server
Architecture: all
Depends: ${perl:Depends}, debianutils (>= 1.7), dosfstools, libappconfig-perl, libxml-parser-perl, libxml-simple-perl, rsync, systemconfigurator (>= 2.0.1), systemimager-boot-i386-standard | systemimager-boot-ia64-standard, systemimager-common (= ${Source-Version})
Recommends: dhcp3-server | dhcp, mkisofs, mtools
Description: Automate GNU/Linux installs and upgrades over a network
 SystemImager is a set of utilities for installing GNU/Linux images to
 clients machines over the network.  Images are stored in flat files on the
 server, making updates easy.  rsync is used for transfers, making updates
 efficient.

Package: systemimager-client
Architecture: all
Depends: ${perl:Depends}, rsync, systemimager-common (= ${Source-Version}), systemconfigurator (>= 2.0.1)
Description: Utilities for creating an image and upgrading client machines
 SystemImager is a set of utilities for installing GNU/Linux images to
 clients machines over the network.  Images are stored in flat files on the
 server, making updates easy.  rsync is used for transfers, making updates
 efficient.
 .
 This package contains utilities for updating a client's image from the
 server, and preparing a client for having it's image fetched by the server.

Package: systemimager-common
Architecture: all
Depends: ${perl:Depends}, rsync
Description: Utilities and libraries common to both the server and client
 SystemImager is a set of utilities for installing GNU/Linux images to
 clients machines over the network.  Images are stored in flat files on the
 server, making updates easy.  rsync is used for transfers, making updates
 efficient.
 .
 This package contains files common to both the systemimager client and server.

Package: systemimager-doc
Section: doc
Architecture: all
Suggests: systemimager-server
Description: Manual and other documentation
 SystemImager is a set of utilities for installing GNU/Linux images to
 clients machines over the network.  Images are stored in flat files on the
 server, making updates easy.  rsync is used for transfers, making updates
 efficient.
 .
 This package contains documentation for SystemImager.

Package: systemimager-boot-${misc:Package-Arch}-standard
Architecture: ${misc:Real-Arch}
Recommends: systemimager-server
Conflicts: systemimager-bin-${misc:Package-Arch}, systemimager-kernel-${misc:Package-Arch}, systemimager-initrd-${misc:Package-Arch}, systemimager-boot-standard-${misc:Package-Arch}, systemimager-server (<< 3.2.2), systemimager-server (>= 3.2.3)
Replaces: systemimager-bin-${misc:Package-Arch}, systemimager-kernel-${misc:Package-Arch}, systemimager-initrd-${misc:Package-Arch}, systemimager-boot-standard-${misc:Package-Arch}
Description: SystemImager boot binaries for ${misc:Package-Arch} client nodes
 SystemImager is a set of utilities for installing GNU/Linux images to
 client machines over the network.  Images are stored in flat
 files on the server, making updates easy.  rsync is used for transfers,
 making updates efficient.
 .
 This package contains the standard flavor of the boot files for installing
 ${misc:Package-Arch} machines.  This package should be installed on the image server.

Package: systemimager-server-flamethrowerd
Architecture: all
Depends: systemimager-server (>=3.2.0), flamethrower
Description: SystemImager boot binaries for ${misc:Package-Arch} client nodes
 SystemImager is a set of utilities for installing GNU/Linux images to
 client machines over the network.  Images are stored in flat
 files on the server, making updates easy.  rsync is used for transfers,
 making updates efficient.
 .
 This package adds support for doing multicast installations.  Multicast
 scales very well, allowing for the installation of hundreds of clients
 at the same time.  Some tuning is required for optimal performance.
 .
 This release requires that your client has enough memory to hold a copy
 of the system image.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKG = systemimager
VERSION = $(shell dpkg-parsechangelog | grep ^Version: | \
                  cut -d " " -f 2 | cut -d "-" -f 1)
BUILD_DIR = $(PKG)-$(VERSION)
UPSTREAM_TARBALL = $(PKG)-$(VERSION).tar.bz2

ARCH = $(shell dpkg --print-architecture)
BOOTPKG = $(PKG)-boot-$(ARCH)-standard

PATCHES=$(sort $(shell find $(CURDIR)/patches -name "*.patch"))

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	@echo -n "Extracting upstream tarball..."
	@tar xfj $(UPSTREAM_TARBALL)
	@echo "done."
	@cd $(BUILD_DIR) && \
          $(foreach patch, $(PATCHES), \
            echo -n Applying `basename $(patch)`... && cat $(patch) | \
	    patch -s -p1 && echo done. &&) /bin/true
	touch configure-stamp

copy_changelog:	$(BUILD_DIR)/changelog

$(BUILD_DIR)/changelog:	$(BUILD_DIR)/CHANGE.LOG
	cd $(BUILD_DIR) && cp CHANGE.LOG changelog

build:	build-arch build-indep

build-indep:	cleandeb configure-stamp build-indep-stamp copy_changelog

build-indep-stamp:
	# the pdf build reports a failure, but the result looks fine...
	-$(MAKE) -C $(BUILD_DIR) docs USE_SGMLTOOLS=1
	touch build-indep-stamp

build-arch:	cleandeb configure-stamp build-arch-stamp copy_changelog

build-arch-stamp:
	dh_testdir

	$(MAKE) -C $(BUILD_DIR) binaries MKCRAMFS=/usr/sbin/mkcramfs

	touch build-arch-stamp

cleandeb:
	-mv debian/control.orig debian/control

clean: cleandeb
	dh_testdir
	dh_testroot
	rm -f build-indep-stamp build-arch-stamp configure-stamp

	# Add here commands to clean up after the build process.
	rm -rf $(BUILD_DIR)
	cd $(CURDIR)/debian && rm -rf $(PKG)-client $(PKG)-server \
	  $(PKG)-common $(PKG)-doc $(BOOTPKG) $(PKG)-boot \
	  $(PKG)-server-flamethrowerd
	rm -f debian/$(PKG)-server.init
	rm -f debian/$(PKG)-server-flamethrowerd.init
	dh_clean

install-arch:	build-arch
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	cd $(CURDIR)/debian && mkdir -p $(BOOTPKG)

	# Add here commands to install the packages
	$(MAKE) -C $(BUILD_DIR) install_binaries \
	  DESTDIR=$(CURDIR)/debian/$(BOOTPKG) PREFIX=/usr

install-indep:	build-indep
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	cd $(CURDIR)/debian && mkdir -p $(PKG)-client \
	  $(PKG)-server $(PKG)-common $(PKG)-doc

	# Add here commands to install the packages
	$(MAKE) -C $(BUILD_DIR) install_client \
	  DESTDIR=$(CURDIR)/debian/$(PKG)-client PREFIX=/usr
	$(MAKE) -C $(BUILD_DIR) install_server \
	  DESTDIR=$(CURDIR)/debian/$(PKG)-server PREFIX=/usr

	# these are installed properly by dh_installinit later
	rm -rf $(CURDIR)/debian/$(PKG)-server/etc/init.d

	$(MAKE) -C $(BUILD_DIR) install_common \
	  DESTDIR=$(CURDIR)/debian/$(PKG)-common PREFIX=/usr

	# the pdf build reports a failure, but the result looks fine...
	-$(MAKE) -C $(BUILD_DIR) install_docs \
	  DESTDIR=$(CURDIR)/debian/$(PKG)-doc PREFIX=/usr USE_SGMLTOOLS=1

	mkdir -p $(CURDIR)/debian/$(PKG)-server-flamethrowerd/etc/systemimager
	mv $(CURDIR)/debian/$(PKG)-server/etc/systemimager/flamethrower.conf \
	  $(CURDIR)/debian/$(PKG)-server-flamethrowerd/etc/systemimager/

# Build architecture-dependent files here.
binary-arch: build-arch install-arch
	dh_testdir -p$(BOOTPKG)
	dh_testroot -p$(BOOTPKG)
	# generate control file suitable for the boot package
	# substvars don't seem to work, so we hack around it with sed.
	cp debian/control debian/control.orig
	sed -e 's/$${misc\:Package\-Arch}/$(ARCH)/g' \
	    -e 's/$${misc\:Real\-Arch}/all/;' \
	       debian/control.in > debian/control
	dh_installdocs -p$(BOOTPKG)
	dh_installchangelogs -p$(BOOTPKG)
	dh_link -p$(BOOTPKG)
	dh_strip -p$(BOOTPKG)
	dh_compress -p$(BOOTPKG)
	dh_fixperms -p$(BOOTPKG)
	dh_installdeb -p$(BOOTPKG)
	dh_perl -p$(BOOTPKG)
	dh_shlibdeps -p$(BOOTPKG)
	dh_gencontrol -p$(BOOTPKG)
	dh_md5sums  -p$(BOOTPKG)
	dh_builddeb -p$(BOOTPKG)

# Build architecture-independent files here.
binary-indep: build-indep install-indep
	dh_testdir -N$(BOOTPKG)
	dh_testroot -N$(BOOTPKG)
#	dh_installdebconf
	# generate control file suitable for the boot package
	# substvars don't seem to work, so we hack around it with sed.
	cp debian/control debian/control.orig
	sed -e 's/$${misc\:Package\-Arch}/$(ARCH)/g' \
	    -e 's/$${misc\:Real\-Arch}/all/;' \
	       debian/control.in > debian/control
	dh_installdocs -N$(BOOTPKG)
	dh_installexamples -p$(PKG)-server $(BUILD_DIR)/doc/local.cfg

	cp ./$(PKG)-$(VERSION)/etc/init.d/$(PKG)-server-rsyncd \
	  ./debian/$(PKG)-server.init
	dh_installinit -p$(PKG)-server --init-script=$(PKG)-server

	cp ./$(PKG)-$(VERSION)/etc/init.d/$(PKG)-server-netbootmond \
	  ./debian/$(PKG)-server.init
	dh_installinit -p$(PKG)-server --init-script=netbootmond

	cp ./$(PKG)-$(VERSION)/etc/init.d/$(PKG)-server-flamethrowerd \
	  ./debian/$(PKG)-server-flamethrowerd.init
	dh_installinit -p$(PKG)-server-flamethrowerd \
	  --init-script=systemimager-server-flamethrowerd

	dh_installchangelogs -N$(BOOTPKG)
	dh_link -N$(BOOTPKG)
	dh_strip -N$(BOOTPKG)
	dh_compress -N$(BOOTPKG)
	dh_fixperms -N$(BOOTPKG)
	dh_installdeb -N$(BOOTPKG)
	dh_perl -N$(BOOTPKG)
	dh_shlibdeps -N$(BOOTPKG)
	dh_gencontrol -N$(BOOTPKG)
	dh_md5sums  -N$(BOOTPKG)
	dh_builddeb -N$(BOOTPKG)

binary: binary-indep binary-arch
.PHONY: build cleandeb clean binary-indep binary-arch binary install configure

## systemimager 3.2.3-3

=== debian/changelog ===
systemimager (3.2.3-3) unstable; urgency=low

  * The Valentin Vidic release.
  * fix updateclient excludes file transform - thanks vvidic.  Closes: #277420
  * fix typo in systemimager-client description - thanks to Florian Zumbiehl.
    Closes: #277256
  * Pass the vga boot parameter to systemconfigurator under the VGA option
    instead of specifying it in the APPEND; a requirement for newer LILOs.
    Thanks again vvidic.  Closes: #277413
  * Move to 2.4.27, removing the kernel.org tarball from this distribution
    and instead adding a build-dep on Debian's kernel-source.  The enclosed
    systemimager tarball is therefore no longer pristine upstream.
  * Remove the bcm5700 driver; it contains non-DFSG firmware
  * Fix a bug in the ssh port forwarding setup in updateclient.  And,
    again, thanks vvidic.  Closes: #277415
  * updateclient should hold open the ssh tunnel to give the rsync
    transactions a longer time to execute - thanks vvidic.  Closes: #277416
  * Force LANG=C in prepareclient, since we only know how to parse sfdisk
    output in english.

 -- dann frazier <dannf@debian.org>  Mon, 08 Nov 2004 00:47:28 -0700

systemimager (3.2.3-2) unstable; urgency=low

  * fix boot packages installability by up'ing the versions of -server
    they conflict with

 -- dann frazier <dannf@debian.org>  Thu, 15 Jul 2004 16:17:24 -0600

systemimager (3.2.3-1) unstable; urgency=low

  * New upstream release.
  * Make mkisofs & mtools dependencies instead of recommends

 -- dann frazier <dannf@debian.org>  Sun, 20 Jun 2004 23:37:57 -0600

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,15 @@
 Section: admin
 Priority: optional
 Maintainer: dann frazier <dannf@debian.org>
-Build-Depends: bc, bin86 [i386], bison, bzip2, cramfsprogs (>= 1.1-4), debhelper (>> 2.0.0), flex, gettext, groff-base, libpopt-dev, libtool, libreadline4-dev, modutils, sysutils, texinfo, util-linux, uuid-dev
+Build-Depends: bc, bin86 [i386], bison, bzip2, cramfsprogs (>= 1.1-4), debhelper (>> 4.0.0), flex, gettext, groff-base, kernel-source-2.4.27, libpopt-dev, libtool, libreadline4-dev, modutils, sysutils, texinfo, uuid-dev
 Build-Conflicts: libc6.1-pic
 Build-Depends-Indep: bc, bzip2, debhelper (>> 2.0.0), docbook-to-man, docbook-utils, jadetex, sgmltools-lite
 Standards-Version: 3.5.7
 
 Package: systemimager-server
 Architecture: all
-Depends: ${perl:Depends}, debianutils (>= 1.7), dosfstools, libappconfig-perl, libxml-parser-perl, libxml-simple-perl, rsync, systemconfigurator (>= 2.0.1), systemimager-boot-i386-standard | systemimager-boot-ia64-standard, systemimager-common (= ${Source-Version})
-Recommends: dhcp3-server | dhcp, mkisofs, mtools
+Depends: ${perl:Depends}, debianutils (>= 1.7), dosfstools, libappconfig-perl, libxml-parser-perl, libxml-simple-perl, mkisofs, mtools, rsync, systemconfigurator (>= 2.0.1), systemimager-boot-i386-standard | systemimager-boot-ia64-standard, systemimager-common (= ${Source-Version})
+Recommends: dhcp3-server | dhcp
 Description: Automate GNU/Linux installs and upgrades over a network
  SystemImager is a set of utilities for installing GNU/Linux images to
  clients machines over the network.  Images are stored in flat files on the
@@ -27,7 +27,7 @@
  efficient.
  .
  This package contains utilities for updating a client's image from the
- server, and preparing a client for having it's image fetched by the server.
+ server, and preparing a client for having its image fetched by the server.
 
 Package: systemimager-common
 Architecture: all
@@ -52,24 +52,24 @@
  .
  This package contains documentation for SystemImager.
 
-Package: systemimager-boot-${misc:Package-Arch}-standard
-Architecture: ${misc:Real-Arch}
+Package: systemimager-boot-ia64-standard
+Architecture: all
 Recommends: systemimager-server
-Conflicts: systemimager-bin-${misc:Package-Arch}, systemimager-kernel-${misc:Package-Arch}, systemimager-initrd-${misc:Package-Arch}, systemimager-boot-standard-${misc:Package-Arch}, systemimager-server (<< 3.2.2), systemimager-server (>= 3.2.3)
-Replaces: systemimager-bin-${misc:Package-Arch}, systemimager-kernel-${misc:Package-Arch}, systemimager-initrd-${misc:Package-Arch}, systemimager-boot-standard-${misc:Package-Arch}
-Description: SystemImager boot binaries for ${misc:Package-Arch} client nodes
+Conflicts: systemimager-bin-ia64, systemimager-kernel-ia64, systemimager-initrd-ia64, systemimager-boot-standard-ia64, systemimager-server (<< 3.2.3), systemimager-server (>= 3.2.4)
+Replaces: systemimager-bin-ia64, systemimager-kernel-ia64, systemimager-initrd-ia64, systemimager-boot-standard-ia64
+Description: SystemImager boot binaries for ia64 client nodes
  SystemImager is a set of utilities for installing GNU/Linux images to
  client machines over the network.  Images are stored in flat
  files on the server, making updates easy.  rsync is used for transfers,
  making updates efficient.
  .
  This package contains the standard flavor of the boot files for installing
- ${misc:Package-Arch} machines.  This package should be installed on the image server.
+ ia64 machines.  This package should be installed on the image server.
 
 Package: systemimager-server-flamethrowerd
 Architecture: all
 Depends: systemimager-server (>=3.2.0), flamethrower
-Description: SystemImager boot binaries for ${misc:Package-Arch} client nodes
+Description: SystemImager boot binaries for ia64 client nodes
  SystemImager is a set of utilities for installing GNU/Linux images to
  client machines over the network.  Images are stored in flat
  files on the server, making updates easy.  rsync is used for transfers,

=== debian/rules ===
--- 
+++ 
@@ -51,6 +51,23 @@
 	$(MAKE) -C $(BUILD_DIR) binaries MKCRAMFS=/usr/sbin/mkcramfs
 
 	touch build-arch-stamp
+
+test:	build-arch-stamp
+	## make sure we haven't blown the floppy size
+	## (we only support floppies on x86)
+ifeq ($(ARCH),i386)
+	$(MAKE) -C $(BUILD_DIR) check_floppy_size
+endif
+	## make sure parted doesn't segfault
+	mkdir mnt
+	mkdir testroot
+	sudo mount $(BUILD_DIR)/initrd_source/initrd mnt -o loop
+	sudo rsync -av mnt/* testroot/
+	sudo umount mnt
+	rmdir mnt
+	cd testroot && sudo tar xvfz ../$(BUILD_DIR)/tmp/boel_binaries.tar.gz
+	sudo chroot testroot /sbin/parted --version
+	sudo rm -rf testroot
 
 cleandeb:
 	-mv debian/control.orig debian/control
